#define CDI_RS232		// allocate memory

#include <pthread.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <time.h>		/* time()	*/
#include <memory.h>
#include <sys/time.h>	/* gethrtime()	*/
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <poll.h>
#include <signal.h>
#include <setjmp.h>

#include <termios.h>

#include <stropts.h>		/* ioctl	*/
#include <semaphore.h>

#include <math.h>

#include "cdi.h"	// interface to user program
#include "cdiRS232Lib.h"

/**************************************/
int filterRS232Bus(int *parameter, int accessFlag)
{
  return 0;
}
/**************************************/
__attribute__((constructor)) void cdiSedacMain(void)
{
  int cc = 0;

  if ((cc=cdiRegisterBusFilter("RS232",filterRS232Bus)) != 0 ) goto err;
  if ((cc=cdiRegisterBusInitialization("RS232",initSerialPortForCDI)) != 0 ) goto err;
  if ((cc=cdiRegisterBusHandler("RS232",execRS232)) != 0 ) goto err;
  if ((cc=cdiRegisterBusCleanup("RS232",closeSerialPort)) != 0 ) goto err;

err:
  if (cc)
  {
    cdilog("%s : failure in bus registration RS232",erlst[cc]);
  }
  return;
}

SER_STRUCT serInfo[N_SERIAL_LINES] = {
	{-1,1}, {-1,2}, {-1,3}, {-1,4} 
};

BAUD_STRUCT baudRate[] = {
//	{0, B0}, 
	{50, B50}, {75, B75}, {110, B110}, {134, B134}, {150, B150},{200, B200},{300, B300}, {600, B600},
	{1200, B1200}, {1800, B1800}, {2400, B2400}, {4800, B4800}, {9600, B9600},{19200, B19200},{38400, B38400},
	{57600, B57600},{115200, B115200}
};
int numBaudRate = sizeof(baudRate) / sizeof(BAUD_STRUCT);

/**************************************/
void rs232String(int cdiLine, char *str, int leng)
{ 
  /* CdiLineInfoBlk *pLine = busHandle[cdiLine]; */
  CdiRequestInfoBlk *pReq;
  /*
  if (NGdebug) 
    dbglog("call Back: cdi line: %d, port number: %d, string: %s, length: %d",
            cdiLine, busHandle[cdiLine]->busLine, str, leng);
  */
  for ( busHandle[cdiLine]->readCounter=0; busHandle[cdiLine]->readCounter < busHandle[cdiLine]->numberActiveRequest; busHandle[cdiLine]->readCounter++ )
  {
    if ( busHandle[cdiLine]->pReqList[ busHandle[cdiLine]->readCounter ].active != recvRequest &&
    busHandle[cdiLine]->pReqList[ busHandle[cdiLine]->readCounter ].active != recvRequest2nd ) continue;
    pReq = &busHandle[cdiLine]->pReqList[ busHandle[cdiLine]->readCounter ];

	if ( pReq->inType == cdiChar )				// string input	*/
	{
	  if ( pReq->conditionFlag == maskChangeWindow || pReq->conditionFlag == maskChangePercent )
	  {
		if ( pReq->requestCounter == 1 ) pReq->dataReturnCondition = DATA_PASS_FILTER; /* first call of Async or sync */
		else if ( pReq->patternFilter == NULL ) pReq->dataReturnCondition = DATA_PASS_FILTER; /* no filter => any data */
		else if ( strcmp(str,pReq->pInData) != 0 ) pReq->dataReturnCondition = DATA_PASS_FILTER; /* data changed compare to last one */
	  }
	  else /* only wait for specific pattern!! */
	  {
		/*if ( strcmp(str, pReq->patternFilter) == 0 ) */
		if ( strstr(str, pReq->patternFilter) != NULL )
		{
		  if ( pReq->conditionFlag == maskCompEqual ) pReq->dataReturnCondition = DATA_PASS_FILTER;
		  /* else if ( pReq->pollFlag ) pReq->dataReturnCondition = DATA_BACK; */
		}
	    else if ( pReq->conditionFlag == maskCompNotEqual ) pReq->dataReturnCondition = DATA_PASS_FILTER;
		/* else if ( pReq->pollFlag ) pReq->dataReturnCondition = DATA_BACK; */
	  }
    }
	else
	{
	  checkReturnCondition(pReq, pReq->pInData, str, leng, 1);
	}
    if ( pReq->dataReturnCondition == 0 ) continue;
    /*
    if (NGdebug) dbglog("rs232 return condition OK: %s",str);
    */
    if ( leng > pReq->inLength ) strncpy( pReq->pInData, str, pReq->inLength);
    else strcpy(pReq->pInData, str);

    cdiExecRequest(&(busHandle[cdiLine]->pReqList[busHandle[cdiLine]->readCounter]), readTaskIndex);
  }
}
/****************************************************************************/
/* send request! input active flag = transRequest or transRequest2nd */
/* after, set active flag to finishRequest, recvRequest, or recvRequest2nd */
/****************************************************************************/
void execRS232(CdiRequestInfoBlk *pReq)
{
  if ( pReq->active == transRequest ) /* start first transfer */
  {
    if ( pReq->accessFlag == cdiWriteFlag || pReq->accessFlag == cdiWriteReadFlag ) /* write first */
    {
      if ( sendSerialPort(((CdiLineInfoBlk *)pReq->pDev->pcdiLine)->busLine, pReq->pOutData) != pReq->outLength )
      {
        pReq->errorCode = rs232_error; /* write failed */
        if ( pReq->perror ) *(pReq->perror) = pReq->errorCode;
        pReq->active = finishRequest;
      } /* finish or 2ndReceive */
      else pReq->active = pReq->accessFlag == cdiWriteFlag ? finishRequest : recvRequest2nd;
    }
    else pReq->active = recvRequest; /* jump to receive */
    return;
  }
  /* second transfer */
  if ( pReq->accessFlag == cdiReadWriteFlag ) /* 2nd write */
  {
    if ( sendSerialPort(((CdiLineInfoBlk *)pReq->pDev->pcdiLine)->busLine, pReq->pOutData) != pReq->outLength )
    {
      pReq->errorCode = rs232_error;
      if ( pReq->perror ) *(pReq->perror) = pReq->errorCode;
    }
    pReq->active = finishRequest;
  }

  return;
}

/********************************************/
#define CDI_PARAMETER_DELIMETER ":"
int cdiParseParamString(char *paramstr,int *parameters)
{
  char *s,*c=NULL;
  int i;
  if (paramstr == NULL || parameters == NULL) return argument_list_error;
  for (s=strtok_r(paramstr,CDI_PARAMETER_DELIMETER,&c), i=0; 
       i<NUMBER_EXEC_PARAM && s != NULL; 
       s=strtok_r(NULL,CDI_PARAMETER_DELIMETER,&c), i++)
  {
    parameters[i] = atoi(s);
  }
  return 0;
}
int initSerialPortForCDI(int busLine, int cdiLine, int numberDevices, char *parameterList)
{
  int parameter[NUMBER_EXEC_PARAM];
  memset(parameter,0,NUMBER_EXEC_PARAM*sizeof(int));
  cdiParseParamString(parameterList,parameter);
  return openSerialPort(busLine, parameter, rs232String, cdiLine);
}

/********************************************/
/*	receive string from port				*/
/********************************************/
//int receiveSerialPortString(int channelNumber, char *pString)
void *GetSerialStringThread(void *param)
{ SER_STRUCT *pSer = (SER_STRUCT *)param;

  do
  {
  	pSer->ret = read(pSer->serFd, pSer->buf, STRING_LENGTH);
	  if ( pSer->canonicalMode )
  	{
	    pSer->buf[pSer->ret] = 0;
	    cdilog(" comport: com%d; canonicalMode input string: %s\n", pSer->channel+1, pSer->buf);
	    pSer->length = pSer->ret;
	  }
  	else
	  {
	    pSer->length = pSer->ret;
	    for ( ; pSer->ret > 0 && pSer->length < STRING_LENGTH; )
	    {
    		FD_ZERO( &(pSer->fdset) );
		    FD_SET( pSer->serFd, &(pSer->fdset) );    

    		pSer->tout.tv_sec = (pSer->usOneChar * 20) / 1000000;		// wait time for 20 char transmission
		    pSer->tout.tv_usec = (pSer->usOneChar * 20) % 1000000;   /* convert to uSeconds */

    		pSer->ret = select( pSer->serFd + 1, &(pSer->fdset), NULL, NULL, &(pSer->tout) );
		    if ( pSer->ret > 0 )	// still data there, no time out
	    	{
	    	  pSer->ret = read(pSer->serFd, &(pSer->buf[pSer->length]), STRING_LENGTH - pSer->length);
		      if ( pSer->ret > 0 ) pSer->length += pSer->ret;
    		}
		    if ( pSer->length >= STRING_LENGTH )
        {
          cdilog("String overflow!!!!!!!!! length: %d(received), %d(maximum); on serial port: com%d;\n",pSer->length, STRING_LENGTH, pSer->channel+1);
          pSer->length = STRING_LENGTH;
        }
        //	if( select( serFd + 1, &fdset, NULL, NULL, &tout ) > 0 )  return read( serFd, c, 1 ) == 1 ? 0 : -1;
      }
  	  pSer->buf[pSer->length] = 0;
  	  cdilog(" comport: %d; input string: %s\n", pSer->channel+1, pSer->buf);
//  strcpy(pString,pSer->buf);
//  return pSer->length;
  	}
	  if (pSer->receiveString) pSer->receiveString(pSer->cdiLine, pSer->buf, pSer->length);
  } while (1);
}

/****************************************/
/* open port 0-3(com1 to com4)			*/
/* parameters[], see header file		*/
/****************************************/
int openSerialPort(int channelNumber, int *parameters, void (*callBack)(int, char*, int), int cdiLine)
{  char devName[16];
   struct termios tio;
   SER_STRUCT *pSer;
   int i;

   if ( channelNumber < 1 || channelNumber > N_SERIAL_LINES ) return -illegal_line;
   channelNumber--;

   for (i=0; i<numBaudRate; i++) if (parameters[paramBaudrate] == baudRate[i].inputBaud) break;
   if ( i == numBaudRate )
   {
  	 cdilog("openSerialPort input wrong! serialport: com%d; baudrate: %d!\n", channelNumber+1, parameters[paramBaudrate]);
	   return -2;
   }

   pSer = &serInfo[channelNumber];
   if ( pSer->serFd >= 0 )
   {
  	 cdilog("serial port: com%d already opened! \n", channelNumber+1);
	   return pSer->serFd;
   }

   sprintf( devName, "/dev/ttyS%d", channelNumber );
   printf("serialPortName=%s\n", devName);

   // open as read, write and not controlling terminal
   if( ( pSer->serFd = open( devName, O_RDWR | O_NOCTTY ) ) < 0 )
   {
  	 printf("open port (com%d) error %d %s\n", channelNumber+1, errno, strerror(errno));
	   return -file_not_open;
   }

   pSer->canonicalMode = parameters[paramCanonicalInput];
   pSer->baudRate = parameters[paramBaudrate];
   pSer->usOneChar = 1000000 / pSer->baudRate * 10;	// 10 bit per char
   tcgetattr( pSer->serFd, &(pSer->oldtio) );
   memset(  &tio, '\0', sizeof(tio) );

   // set control modes

   /* tio.c_cflag = B38400 | CRTSCTS | CS8 | CLOCAL | CREAD; */
   // bartrate, RTSc control, 7 data bits, 2 stop bits, even parity, no modem, enable receiver 
   //   tio.c_cflag = B9600 | CRTSCTS | CS7 | CSTOPB | PARENB | CLOCAL | CREAD; 
   
   // baudRate, no modem control, enable read
   tio.c_cflag = baudRate[i].defBaud | CLOCAL | CREAD | (parameters[param8bits] == 0 ? CS7 : CS8);
   if ( parameters[param2StopBits] ) tio.c_cflag |= CSTOPB;
   if ( parameters[paramParity] ) tio.c_cflag |= PARENB;
   if ( parameters[paramOddParity] ) tio.c_cflag |= (PARENB | PARODD);
   if ( parameters[paramFlowControl]) tio.c_cflag |= CRTSCTS;

   // input modes
   tio.c_iflag = IGNPAR;	/* ignore bytes with framing and parity error */
   if ( parameters[paramCanonicalInput] ) tio.c_iflag |= ICRNL;

   // output modes
   tio.c_oflag = 0;			// raw output

   // local modes
   tio.c_lflag = parameters[paramCanonicalInput] ? ICANON : 0;/* non-canonical input mode */

   // control chars
   tio.c_cc[VTIME]  = 0;  /* do not use inter-character timer */
   tio.c_cc[VMIN]   = 1;  /* blocking read until 1 character received */
  
   tcflush( pSer->serFd, TCIOFLUSH );
   tcsetattr( pSer->serFd, TCSANOW, &tio );

   pSer->channel = channelNumber;
   pSer->cdiLine = cdiLine;
   pSer->receiveString = callBack;
	// Waiting for messages and work them out on master module
   if ( pthread_create( &(pSer->tIdMaster), NULL, GetSerialStringThread, (void *)pSer ) )
   {
	  cdilog ("pthread_create error for serial port: com%d",channelNumber+1);
	  tcflush( pSer->serFd, TCIOFLUSH );
	  tcsetattr( pSer->serFd, TCSANOW, &(pSer->oldtio) );
	  close( pSer->serFd );
	  pSer->serFd = -1;
	  return -un_allocated;
   }

   cdilog("open serialPort OK! serial port: com%d\n", channelNumber+1);
   printf("open serialPort OK! serial port: com%d\n", channelNumber+1);
  
   return pSer->serFd;
}

/****************************************/
/*	Close								*/
/****************************************/
int closeSerialPort(int channelNumber)
{ SER_STRUCT *pSer;

  if ( channelNumber < 1 || channelNumber > N_SERIAL_LINES ) return -illegal_line;

  cdilog("close serialPort! com%d\n", channelNumber);
  pSer = &serInfo[--channelNumber];

  if ( pSer->serFd < 0 ) return -file_not_open;
  pthread_cancel( pSer->tIdMaster );
  tcflush( pSer->serFd, TCIOFLUSH );
  tcsetattr( pSer->serFd, TCSANOW, &(pSer->oldtio) );
  close( pSer->serFd );
  pSer->serFd = -1;
  return 0;
}

/****************************************/
/*	send String							*/
/****************************************/
int sendSerialPort(int channelNumber, char *psOutput)
{ int iOut;
  SER_STRUCT *pSer = &serInfo[--channelNumber];

  if ( pSer->serFd < 0 )
  {
    cdilog(" port is not open yet! comport: com%d\n", channelNumber+1);
    return -file_not_open;
  }

  iOut = write(pSer->serFd, psOutput, strlen(psOutput));

  if (iOut < 0)
  {
    cdilog("write serial port(com%d) error %d %s\n", channelNumber+1, errno, strerror(errno));
  }
  else
  {
    printf("wrote %d chars: %s on serial port: com%d\n", iOut, psOutput, channelNumber+1);
  }

  return iOut;
}
