// SedPc.c	210207	Stadtmueller	mst3	150703
//
//	SedPc - Testprogram


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include "SedPc.h"

LONG	ln, ca, sa, dly;


//-------+---------+---------+---------+---------+---------+---------+---------+

// help		list all commands

void help ( void )

{
	printf( "Help for SedPc TestProgram \n" );
	printf( " h - help \n" );
	printf( " q - quit \n" );
	printf( " 1 - dec/hex string to long \n" );
	printf( " 2 - print global variables \n" );
	printf( " 3 - port-io test \n" );
	printf( " a - ask for crate- and sub-address \n" );
	printf( " \n" );
	printf( " i - SedIni - initialize and select one line \n" );
	printf( " c - SedClr - clear fifo's in SedPc \n" );
	printf( " r - SedRd  - send a read-telegram \n" );
	printf( " w - SedWr  - send a write-telegram \n" );
	printf( " b - SedPut/SedGet - send a block of telegrams \n" );
	printf( " B - SedPut/SedGet - loop test \n" );
	printf( " \n" );
	printf( " y - SedDly - get/set delay \n" );
	printf( " l - SedLcs - look for crate- and sub-addr \n" );
	printf( " d - SedDef - set SedPc to defaults \n" );
	printf( " s - SedSta - get/clear status \n" );
	printf( " v - SedLib/SedVer/SedTyp - get version-strings \n" );
	printf( " \n" );
	printf( " t - SedTst - enable/disable test-telegrams \n" );
	printf( " f - SedFt  - fifo-test \n" );
	printf( " e - SedEst - enable selftest at next reset \n" );
	printf( " n - SedCac/SedCnt/SedErc - read/clear counter \n" );
	printf( " \n" );

	return;

}		// end of help
//-------+---------+---------+---------+---------+---------+---------+---------+

// askdec	ask for a decimal value
//
//	in:		askstr - string with question
//	i/o:	value  - default-value if you hit Enter or new value
//	ret:	0 = ok, other = error
//

LONG askdec ( CHAR *askstr, LONG *value )

{
	static CHAR	str[8], *pstr;
	static LONG	err, len;

	err = 0;
	printf( "%s%u > ", askstr, *value );
	pstr = fgets(str, 8, stdin);
	len = strlen(str) - 1;
	str[len] = NUL;
	if ( len )							// new input
		err = dstrtu(str, value);

	return( err );

}		// end of askdec
//-------+---------+---------+---------+---------+---------+---------+---------+

// askhex	ask for a hexadecimal value
//
//	in:		askstr - string with question
//	i/o:	value  - default-value if you hit Enter or new value
//	ret:	0 = ok, other = error
//

LONG askhex ( CHAR *askstr, LONG *value )

{
	static CHAR	str[8], *pstr;
	static LONG	err, len;

	err = 0;
	printf( "%s0x%x > 0x", askstr, *value );
	pstr = fgets(str, 8, stdin);
	len = strlen(str) - 1;
	str[len] = NUL;
	if ( len )							// new input
		err = hstrtu(str, value);

	return( err );

}		// end of askhex
//-------+---------+---------+---------+---------+---------+---------+---------+

// askaddr	ask for crate- and sub-address
//
//	ret:	0 = ok, other = error
//

LONG askaddr ( void )

{
	static CHAR	str[64], *pstr;
	static LONG	err;

	pstr = strcpy( str, "sub-address   = " );
	err = askdec( str, &sa );

	return( err );

}		// end of askaddr
//-------+---------+---------+---------+---------+---------+---------+---------+

// prn_external		print values of externals

void prn_external ( void )

{
	int i;

	printf( "\n  print global variables \n" );
	printf( "number of lines found: %u \n", glNoLin );
	printf( "logical line-numbers: " );
	for ( i = 0; i < glNoLin; i++ )
		printf( "%8u", glLogLin[i] );
	printf( " \n" );
	printf( "device addresses:     " );
	for ( i = 0; i < glNoLin; i++ )
		printf( "   0x%3x", glDevAdr[i] );
	printf( " \n" );
	printf( "module addresses:     " );
	for ( i = 0; i < glNoLin; i++ )
		printf( "   0x%3x", glModAdr[i] );
	printf( " \n" );
	printf( "last selected line: %u \n", glSelLin );
	printf( "delay-time in us  : %u \n", glTelDly );
	printf( "port-addr for data, status and control : 0x%x  0x%x  0x%x \n",
				glDatReg, glStaReg, glCtrReg );

	return;

}		// end of prn_external
//-------+---------+---------+---------+---------+---------+---------+---------+

// tst_conv		test convert routines

void tst_conv ( void )

{
	LONG dat, err;
	CHAR str[12];

	printf( "\n  test hstrtu - hex-string to unsigned long \n" );
	strcpy(str, "ab345678");
	err = hstrtu(str, &dat);
	printf( "str=%s, dat=0x%x, err=0x%x \n", str, dat, err );
	strcpy(str, "123");
	err = hstrtu(str, &dat);
	printf( "str=%s, dat=0x%x, err=0x%x \n", str, dat, err );
	strcpy(str, "efg");
	err = hstrtu(str, &dat);
	printf( "str=%s, dat=0x%x, err=0x%x \n", str, dat, err );

	printf( "\n  test dstrtu - dec-string to unsigned long \n" );
	strcpy(str, "4000123000");
	err = dstrtu(str, &dat);
	printf( "str=%s, dat=%u, err=0x%x \n", str, dat, err );
	strcpy(str, "123");
	err = dstrtu(str, &dat);
	printf( "str=%s, dat=%u, err=0x%x \n", str, dat, err );
	strcpy(str, "a23");
	err = dstrtu(str, &dat);
	printf( "str=%s, dat=%u, err=0x%x \n", str, dat, err );

	return;

}		// end of tst_conv
//-------+---------+---------+---------+---------+---------+---------+---------+

// tst_fifo		test fifo

void tst_fifo ( void )

{
	#define	MAXLEN	4096
	#define	MINLEN	16

	static LONG	derr, serr, err, i, iw;
	static LONG	len = MAXLEN, snd[MAXLEN], rcv[MAXLEN];
	static LONG	willi[7] = {0x0, 0xffff, 0xaaaa, 0x5555, 0x1ce3, 0xe31c, 0x1fe};
	static CHAR	str[64], *pstr;

	printf( "\n  test fifo   -   Enter = take old value \n" );

	pstr = strcpy( str, "block-length = ");
	err = askdec( str, &len );
	if ( len > MAXLEN )
		len = MAXLEN;
	else if ( len < (MINLEN) )
		len = MINLEN;

	iw = 0;
	for ( i = 0; i < len; i++ ) {		// fill pattern-buffer
		snd[i] = willi[iw++];
		if ( iw >= 7 )
			iw = 0;
	}

	SedFt( ln, snd, rcv, len - 8, &derr, &serr, &err );
	printf( "SedFt  - fifo-test --> %u data-errors, %u status-errors, err = 0x%x \n",
				derr, serr, err );

exit:
	return;

}		// end of tst_fifo
//-------+---------+---------+---------+---------+---------+---------+---------+

// tst_port		test port-io

void tst_port ( void )

{
	static LONG	port = 0x378, len, err;
	static LONG	dat, sta, ctr;
	static CHAR	cmd, str[64], *pstr;

	printf( "\n  test port-io   -   Enter = take old value \n" );

	pstr = strcpy( str, "port-base-addr = ");
	err = askhex( str, &port );

	pstr = strcpy( str, "data-reg       = ");
	err = askhex( str, &dat );

	pstr = strcpy( str, "control-reg    = ");
	err = askhex( str, &ctr );

	if ( ioperm(port, 3, 1) ) {			// get access to ports
		perror("ioperm");
		exit(1);
	}

	_outp(port, (CHAR)dat);				// set data-register
	_outp(port+2, (CHAR)ctr);			// set control-register-register

	dat = (LONG)_inp(port);				// read ports
	sta = (LONG)_inp(port + 1);
	ctr = (LONG)_inp(port + 2);

	printf( "port = 0x%x - dat = 0x%x - sta = 0x%x - ctr = 0x%x \n",
				port, dat, sta, ctr );

	if ( ioperm(port, 3, 0) ) {			// release access to ports
		perror("ioperm");
		exit(1);
	}

	return;

}		// end of tst_port
//-------+---------+---------+---------+---------+---------+---------+---------+

// tst_putget		test put and get functions
//						test-pattern: WilliPattern

void tst_putget ( void )

{
	#define	MAXTEL	4096 / 5	// max number of telegrams fit to fifo-size
	#define	MINTEL	2

	static LONG	derr, serr, err, i, iw, n;
	static LONG	len = MAXTEL, snd[MAXTEL*3], rcv[MAXTEL*3];
	static LONG	willi[7] = {0x0, 0xffff, 0xaaaa, 0x5555, 0x1ce3, 0xe31c, 0x1fe};
	static LONG	WrCa, RdCa;
	static CHAR	str[64], *pstr;

	for ( i = 0; i < (MAXTEL*3); i++ ) {		// clear buffer with count
		snd[i] = i;
		rcv[i] = i;
	}

	printf( "\n  send a block of telegrams   -   Enter = take old value \n" );

	pstr = strcpy( str, "block-length = ");
	err = askdec( str, &len );
	len &= 0xfffe;
	if ( len > MAXTEL )
		len = MAXTEL;
	else if ( len < (MINTEL) )
		len = MINTEL;

	WrCa = 0x40 | ca;						// function write and crate-addr
	RdCa = 0x80 | ca;						// function read  and crate-addr
	iw = 0;
	for ( i = 0; i < (len/2); i++ ) {		// fill pattern-buffer
		snd[i*6+0] = WrCa;
		snd[i*6+1] = sa;
		snd[i*6+2] = willi[iw++];
		snd[i*6+3] = RdCa;
		snd[i*6+4] = sa;
		snd[i*6+5] = 0;
		if ( iw >= 7 )
			iw = 0;
	}

	n = len;
	SedPut( ln, &n, snd, &err );		// send telegrams
	printf( "SedPut  - send a block of wr/rd-telegrams --> err = 0x%x \n", err );

	n = len;
	SedGet( ln, &n, rcv, &err );		// receive telegrams
	printf( "SedGet  - recv a block of wr/rd-telegrams --> err = 0x%x \n", err );

	serr = derr = 0;
	for ( i = 0; i < (len/2); i++ ) {		// check status and data
		if ( (rcv[i*4+0] & 0xc0) != 0x40 )	// status write ?
			serr++;
		if ( (rcv[i*4+2] & 0xc0) != 0x80 )	// status read ?
			serr++;
		if ( rcv[i*4+3] != snd[i*6+2] )		// data not equal ?
			derr++;
	}

	printf( "SedGet  - %u telegrams --> %u status-errors, %u data-errors \n",
				len, serr, derr );

	n = 0;
	printf( "\ntel no  -  snd0  snd1  snd2  -  rcv0  rcv1  <--  array-data \n\n" );
	for ( i = 0; i < (len); i++ ) {
		printf( "%6u  -%6x%6x%6x  -%6x%6x \n",
				 i, snd[i*3+0], snd[i*3+1], snd[i*3+2], rcv[i*2+0], rcv[i*2+1] );
		if ( i && !(i & 0xf) && (n < 2) ) {
			pstr = strcpy( str, "break = 0, more = 1, all = 2 ?   ");
			err = askdec( str, &n );
			if ( !n )
			goto exit;
	}	}

exit:
	return;

}		// end of tst_putget
//-------+---------+---------+---------+---------+---------+---------+---------+

// loop_putget		loop test put and get functions
//						test-pattern: count

void loop_putget ( void )

{
	#define	MAXTEL	4096 / 5	// max number of telegrams fit to fifo-size
	#define	MINTEL	2

	static LONG	derr, serr, perr, gerr;						// counter
	static LONG	lgdat, lbdat, prnerr, chksta, chkdat;		// last good / bad data
	static LONG	pute, gete, wrs, rds;						// error, status
	static LONG	data = 0;									// test-data
	static LONG	loop, endl = 1000, prnl;					// loop counter
	static LONG	err, i, n;
	static LONG	len = MAXTEL, snd[MAXTEL*3], rcv[MAXTEL*3];	// buffer, blocklength
	static LONG	WrCa, RdCa;									// wr/rd funct + address
	static CHAR	str[64], *pstr;

	printf( "\n  loop sending a block of telegrams   -   Enter = take old value \n" );

	pstr = strcpy( str, "block-length = ");	// ask for block-length
	err = askdec( str, &len );
	len &= 0xfffe;
	if ( len > MAXTEL )
		len = MAXTEL;
	else if ( len < (MINTEL) )
		len = MINTEL;

	pstr = strcpy( str, "number of blocks to run = ");	// ask for number of blocks
	err = askdec( str, &endl );

	derr = serr = perr = gerr = loop = prnl = 0;		// clear counter
	pute = gete = wrs = rds = prnerr = 0;				// clear last error / status
	lgdat = lbdat = 0;
	WrCa = 0x40 | ca;						// function write and crate-addr
	RdCa = 0x80 | ca;						// function read  and crate-addr

	while ( ++loop <= endl ) {	// loop the test

		for ( i = 0; i < (len/2); i++ ) {		// fill pattern-buffer
			data &= 0xffff;						// make 16 bit test-data
			snd[i*6+0] = WrCa;						// setup write-telegram
			snd[i*6+1] = sa;
			snd[i*6+2] = data++;
			snd[i*6+3] = RdCa;						// setup read-telegram
			snd[i*6+4] = sa;
			snd[i*6+5] = 0;
		}

		chksta = 1;
		n = len;
		SedPut( ln, &n, snd, &err );		// send telegrams
		if ( err ) {						// put-error?
			perr++;
			prnerr++;
			chksta = 0;
			pute = err;
		}
//printf( "SedPut:  Loop=%u   PutErr=%u   GetErr=%u   StaErr=%u   DatErr=%u \n",
//		loop, perr, gerr, serr, derr );

		n = len;
		SedGet( ln, &n, rcv, &err );		// receive telegrams
		if ( err > 7 ) {					// get-error?
			gerr++;
			prnerr++;
			chksta = 0;
			gete = err;
		}
//printf( "SedGet:  Loop=%u   PutErr=%u   GetErr=%u   StaErr=%u   DatErr=%u \n",
//		loop, perr, gerr, serr, derr );

		for ( i = 0; i < (len/2); i++ ) {		// check status and data
			chkdat = 1;
			if ( ((rcv[i*4+0] & 0xc7) != 0x40) && chksta ) {	// status write ?
				serr++;
				prnerr++;
				chkdat = 0;
				wrs = rcv[i*4+0];
			}
			if ( ((rcv[i*4+2] & 0xc7) != 0x80) && chksta ) {	// status read ?
				serr++;
				prnerr++;
				chkdat = 0;
				rds = rcv[i*4+2];
			}
			if ( (rcv[i*4+3] != snd[i*6+2]) && chksta && chkdat ) {	// data not equal ?
				derr++;
				prnerr++;
				lgdat = snd[i*6+2];				// store last good / bad data
				lbdat = rcv[i*4+3];
			}
		}
//printf( "Check:   Loop=%u   PutErr=%u   GetErr=%u   StaErr=%u   DatErr=%u \n",
//		loop, perr, gerr, serr, derr );

		if ( ((loop - prnl) * len) >= 10000 ) {		// printout at 10000 telegrams
			prnl = loop;
			printf( "Loop=%u   PutErr=%u   GetErr=%u   StaErr=%u   DatErr=%u \n",
					loop, perr, gerr, serr, derr );
			if ( prnerr ) {
				printf("*** PutErr = 0x%x   GetErr = 0x%x  ", pute, gete);
				printf("WrStat = 0x%x   RdStat = 0x%x \n", wrs, rds);
				printf("*** GoodDa = 0x%x   BadDat = 0x%x \n", lgdat, lbdat);
				pute = gete = wrs = rds = prnerr = lgdat = lbdat = 0;
			}
		}

	} // while ( loop ... )

	printf( "Loop=%u   PutErr=%u   GetErr=%u   StaErr=%u   DatErr=%u \n",
				--loop, perr, gerr, serr, derr );

exit:
	return;

}		// end of loop_putget
//-------+---------+---------+---------+---------+---------+---------+---------+

main(int argc,char *argv[])

{
	int		cmd = 'i', ret, i;
	CHAR	str[256], *pstr;
	LONG	FoundLines, LineNumbers[XMLN], DeviceAddr[XMLN];
	LONG	dat = 0, err, l, m, n;
	LONG	HdwTyp, HdwRel, FirVer, FirRel, FifLen;
	LONG	arr[256];

	printf( "SedPc TestProgram \n" );

	ln = 1;
	ca = 3;
	sa = 1;

	while ( 1 ) {				// loop
		printf( "\n --- command --- > %c > ", cmd );
		ret = getchar( );		// get command
		if ( ret != LF ) {		// new command
			cmd = ret;
			ret = getchar( );		// get Enter (LF)
		}

		switch ( cmd ) {		// perform the commands

		case 'a':					// a - ask for crate- and sub-address
			pstr = strcpy( str, "line-number for this session = " );
			err = askdec( str, &ln );
			pstr = strcpy( str, "crate-address = " );
			err = askdec( str, &ca );
			err = askaddr( );
			break;

		case 'i':					// i - SedIni - initialize and select one line
			printf( "SedIni - initialize and select one line " );
			SedIni( &FoundLines, LineNumbers, DeviceAddr, &err );
			printf( "--> err = 0x%x \n", err);
			prn_external();
			pstr = strcpy( str, "line-number for this session = " );
			err = askdec( str, &ln );
			pstr = strcpy( str, "crate-address = " );
			err = askdec( str, &ca );
			err = askaddr( );
			cmd = 'h';
			break;

		case 'c':					// c - SedClr - clear SedPc and get delay
			SedClr( ln, &dly, &err );
			printf( "SedClr - clear SedPc --> delay = %u, err = 0x%x \n", dly, err );
			break;

		case 'r':					// r - SedRd  - send a read-telegram
			err = askaddr( );
			SedRd( ln, ca, sa, &dat, &err );
			printf( "SedRd  - read telegram --> data = 0x%x, err = 0x%x \n", dat, err );
			break;

		case 'w':					// w - SedWr  - send a write-telegram
			err = askaddr( );
			pstr = strcpy( str, "data     = " );
			err = askhex( str, &dat );
			SedWr( ln, ca, sa, dat, &err );
			printf( "SedWr  - write telegram --> data = 0x%x, err = 0x%x \n", dat, err );
			break;

		case 'b':					// b - SedPut/SedGet - send a block of telegrams
			tst_putget( );
			break;

		case 'B':					// B - SedPut/SedGet - loop test
			loop_putget( );
			break;

		case 'y':					// y - SedDly - get/set delay
			dat = -1;
			SedDly( ln, &dat, &err );
			printf( "SedDly - get/set delay --> delay = %u usec, err = 0x%x \n",
						dly, err );
			pstr = strcpy( str, "new delay = " );
			err = askdec( str, &dly );
			SedDly( ln, &dly, &err );
			printf( "SedDly - get/set delay --> delay = %u usec, err = 0x%x \n",
						dly, err );
			break;

		case 'l':					// l - SedLcs - look for crate- and sub-addr
			SedLcs( ln, 128, &dat, arr, &err );		// look for crates
			printf( "SedLcs - look for crates --> %u crates found, err = 0x%x \n",
						dat, err );
			SedLcs( ln, ca, &dat, arr, &err );		// look for subaddresses
			printf( "SedLcs - look for subadd --> %u subadd found, err = 0x%x \n",
						dat, err );
			break;

		case 'd':					// d - SedDef - set SedPc to defaults
			SedDef( ln, &err );
			printf( "SedDef - set SedPc to defaults --> err = 0x%x \n", err );
			break;

		case 's':					// s - SedSta - get/clear status
			l = 0;
			pstr = strcpy( str, "clear some bits after read? (0=no, 1=yes) = " );
			err = askdec( str, &l );
			SedSta( ln, l, &dat, &err );
			printf( "SedSta - get/clear status --> status = 0x%x, err = 0x%x \n",
						dat, err );
			break;

		case 'v':					// v - SedLib/SedVer/SedTyp - get version-strings
			SedLib( str );
			printf( "SedLib - %s \n", str);
			SedVer( ln, str, &err );
			if ( !err )
				printf( "SedVer - %s \n", str);
			else
				printf( "SedVer - error = 0x%x \n", err);
			SedTyp( ln, &HdwTyp, &HdwRel, &FirVer, &FirRel, &FifLen, &err );
			if ( !err )
				printf( "SedTyp - Hardware %u.%u   Firmware %u.%u   FifoLength %u \n",
							HdwTyp, HdwRel, FirVer, FirRel, FifLen);
			else
				printf( "SedTyp - error = 0x%x \n", err);
			break;

		case 't':					// t - SedTst - enable/disable test-telegrams
			SedTst( ln, 8, &l, &m, &n, &err );
			printf( "SedTst - ask for test-telegram --> err = 0x%x \n", err );
			if ( l )
				dat = 1;	// TestTel is running
			else
				dat = 0;	// TestTel is not running
			pstr = strcpy( str, "enable test-telegrams? (0=no, 1=yes) = " );
			err = askdec( str, &dat );
			if ( dat )
				dat = 1;
			SedTst( ln, dat, &l, &m, &n, &err );
			printf( "SedTst - enable/disable test-telegrams --> err = 0x%x \n", err );
			break;

		case 'f':					// f - SedFt  - fifo-test
			tst_fifo( );
			break;

		case 'e':					// e - SedEst - enable selftest at next reset
			SedEst( ln, &err );
			printf( "SedEst - enable selftest at next reset --> err = 0x%x \n", err );
			break;

		case 'n':					// n - SedCac/SedCnt/SedErc - read/clear counter
			SedCnt( ln, arr, &err );
			printf( "SedCnt - long-word counter --> err = 0x%x \n", err );
			printf( "User RdTel       = %u \n", arr[0] );
			printf( "User WrTel       = %u \n", arr[1] );
			printf( "TestTel          = %u \n", arr[2] );
			printf( "SpecialFunctions = %u \n", arr[3] );
			printf( "CPs              = %u \n", arr[4] );
			printf( "changes delay    = %u \n", arr[5] );
			printf( "changes TestTel  = %u \n", arr[6] );
			printf( "n.a.             = %u \n", arr[7] );
			printf( "ResponseErrors   = %u \n", arr[8] );
			printf( "SedacErrors      = %u \n", arr[9] );
			printf( "MysteriousErrors = %u \n", arr[10] );
			printf( "InternalErrors   = %u \n", arr[11] );
			printf( "RspErr Bitfield  = 0x%x \n", arr[12] );
			printf( "SedErr Bitfield  = 0x%x \n", arr[13] );
			printf( "MysErr Bitfield  = 0x%x \n", arr[14] );
			printf( "n.a.             = 0x%x \n", arr[15] );
			printf( "\n" );
			SedErc( ln, ca, 0, arr, &err );
			printf( "SedErc - error-counter, ca = %u, class RspErr --> err = 0x%x \n",
						ca, err );
			printf( "here the counter for subaddr 0 .. 7, 8 .. 15, ...\n" );
			printf( "%8u%8u%8u%8u%8u%8u%8u%8u \n",
			arr[0], arr[1], arr[2], arr[3], arr[4], arr[5], arr[6], arr[7] );
			printf( "%8u%8u%8u%8u%8u%8u%8u%8u \n",
			arr[8], arr[9], arr[10], arr[11], arr[12], arr[13], arr[14], arr[15] );
			printf( "%8u%8u%8u%8u%8u%8u%8u%8u \n",
			arr[16], arr[17], arr[18], arr[19], arr[20], arr[21], arr[22], arr[23] );
			printf( "%8u%8u%8u%8u%8u%8u%8u%8u \n",
			arr[24], arr[25], arr[26], arr[27], arr[28], arr[29], arr[30], arr[31] );
			printf( "\n" );
			l = 0;
			pstr = strcpy( str, "clear all counter? (0=no, 1=yes) = " );
			err = askdec( str, &l );
			if ( l ) {
				SedCac( ln, &err );
				printf( "SedCac - clear all counter --> err = 0x%x \n", err );
			}
			break;

		case '1':					// 1 - dec/hex string to long
			tst_conv( );
			break;
		case '2':					// 2 - print global variables
			prn_external( );
			break;
		case '3':					// 3 - port-io test
			tst_port( );
			break;

		case CR:					// CR  - ignore
		case LF:					// LF  - ignore
			break;
		case EOF:					// EOF - input, exit program
			printf( "\nEOF input - program terminated\n\n" );
		case 'q':					// q   - quit
		case ESC:					// ESC - quit
			goto exi;

		default:					// wrong command - give help
			help( );
			break;
		} // switch
	} // while

exi:
	SedExi( &err );
	if ( err )
		printf( "Error in SedExi = 0x%x \n", err );
	exit( 0 );

}		// end of main

// end of SedPc.c
