#ifndef CDISEDAC_H_
#define CDISEDAC_H_

#include "cdi.h"
#include "sedacDrv.h"

#define N_SEDAC_LINES	8	/* maximum number of sedac lines */
#define u16 unsigned short

enum execSedacParamIndex
{
  sedacSubOffset,       /* sedac subaddress offset for read */
  sedacSubOffsetSecond, /* second sedac subaddress offset for write *//*cdiReadWrite or cdiWriteRead */
  sedacSubOffsetThird,  /* sedac subaddress offset for second write cdiWriteReadWrite */
};

typedef struct {
  int sedac_fd;		/* sedac File descripter */
  int cdiLine;
  
  PSEDAC_DATA da;	/* dynamic allocation */
  int dataSize;

  u16 sedacSimulationBuffer;
  u16 sedacSimulationCount;
} SEDAC_STRUCT;

int execSedac(u16 ln, u16 *crate, u16 *subadd, int *RWF, u16 *data, int nwords, int flag);
int RegisterSedacBus(void);
int initSedacForCDI(int busLine, int cdiLine, int numberDevices, char *parameterList);
int sedacCmp(u16 ln, u16 crate, u16 subadd, int RWF, u16 *data, int nwords, int *cmpflag);
int doSedacRequest(CdiRequestInfoBlk *pReq, int step);
int sedacScanFcn(char *target,char *result,int resultBufferSize);
void execSedacBus(CdiRequestInfoBlk *pReq);
int exitSedac(int ln);
int filterSedacBus(int *parameter, int accessFlag);

/* hmmmmm .... do we need this ? */
#define READ 1 /* for sedac input parameter */
#define WRITE -1

/* init */
extern int initSedac(int ln);
extern int exitSedac(int ln);

/* group read-write */
extern int sedac(u16 ln, u16 crate, u16 subadd, int RWF, u16 *data, int nwords);
extern int nsedac(u16 ln, u16 *crate, u16 *subadd, int *RWF, u16 *data, int nwords);

/* single read-write */
extern int wsedac(u16 ln, u16 crate, u16 subadd, u16 data);
extern int rsedac(u16 ln, u16 crate, u16 subadd, u16 *data);

/* find sub or crate address */
extern int F_addr(int *naddr, int rwflag, u16 ln, u16 crate);
extern int F_crates(int *ncrates, int rwflag, u16 ln);

#endif /* CDISEDAC_H_ */


